
//07.05.2006    +    qualFloat(int unsigned u, v, float epsilon)
//06.05.2006	+   
//		BOOLEAN VecCompar(int unsigned LpV1, LpV2)

//06.05.2006	   VectorNormalize2(#Normal3v);
//		    ESI, EDI
//05.05.2006     .
//      
//#pragma option ba-     //  


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//                                   @
//                                  @
//                                 @    @@@@@                @
//                    @           @    @     @               @                   @@@@@
//                     @         @    @      @      @@@      @          @@@@    @    @
//                      @       @     @     @      @         @         @    @  @     @
//                       @     @       @   @      @      @@@@@@@@@@   @     @  @     @
//                        @   @         @ @      @           @       @      @  @   @@
//                         @ @           @    @  @           @       @      @  @@@@@
//                          @             @  @   @           @       @      @  @@
//                                         @@     @          @       @     @   @ @
//                                                 @          @   @   @   @    @  @
//                                                  @@         @@@     @@@     @   @@
//
//                               3D  2D 
//
//
//                                                  ####
//                                                 #
//                                                 #     ### ###
//                                                 #
//                                                  ####
//
//
//
//
//
//
//
//
//
//
//
// 22.11.2005 ComputeNormal( DWORD LpV0, LpV1, LpV2, LpOutNormal)
//             
//TransformInMatrix(int unsigned vec, matrix)
//ADD UPDATE 12.03.2005      This returns the intersection point of the line that intersects the plane
//                           IntersectionPoint( DWORD LpOut, DWORD LpPoint, LpNormal, LpLineA, LpLineB)
//ADD UPDATE 28.02.2005      ClosestPointOnLine
//ADD UPDATE 28.02.2005      IntersectedLinePlane
//ADD UPDATE 28.02.2005      float PlaneDistance(DWORD LpNormal, LpPoint) This returns the distance between a plane and the origin
//ADD UPDATE 28.02.2005      float Distance(DWORD vPoint1,  vPoint2) This returns the distance between 2 3D points

//ADD UPDATE 28.02.2005      void VectorSub (DWORD LpV1,  LpV2,  LpOut)    LpV2  LpV1,    LpOut
//ADD UPDATE 28.02.2005      void VectorInverse (DWORD LpVector)  -   
//ADD UPDATE 27.02.2005      VectorNormalize(DWORD LpVector) - 
//ADD UPDATE 02.01.2005      VectorLength(DWORD LpVector)
//ADD UPDATE 02.01.2005      CalcNormal(DWORD LpVertex1, LpVertex2, LpVertex3, LpLpNormals)
//ADD UPDATE 14.11.2004      egwSqrt
//ADD UPDATE 05.11.2004
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////




// : ---------------------------------------------------------------------------------------
//
//CopyVector(EAX, EBX)
//Add
//MulByScalar
//DotProduct
//CrossProduct
//VectorLength(DWORD LpVector)


//   
//CalcNormal(DWORD LpVertex1, LpVertex2, LpVertex3, LpLpNormals)



//#define PI 3.141592654
#define PI 3.141592

struct Vector3 {
float X;
float Y;
float Z;

};

#ifndef glMat16
struct glMat16{
float m[16];
};
#endif




// ,      TRUE
:BOOLEAN VecCompar(int unsigned LpV1, LpV2)
USES ESI, EDI
{
float v1, v2;
ESI=LpV1;
EDI=LpV2;

v1=DSFLOAT[#ESI.Vector3.X];
v2=DSFLOAT[#ESI.Vector3.X];

if (v1==v2) {
		v1=DSFLOAT[#ESI.Vector3.Y];
		v2=DSFLOAT[#ESI.Vector3.Y];
		if (v1==v2) {


				v1=DSFLOAT[#ESI.Vector3.Z];
				v2=DSFLOAT[#ESI.Vector3.Z];

				if (v1==v2)  { EAX=1;  return EAX;}

		            }

	}

$XOR EAX, EAX; return EAX;
}
//-------------------------------------------------------------


/* returns the absolute value of a float */
:float floatAbs(float f)
{
    IF (f < 0.0)-f;
//        RETURN -f;
    return f;
}



/* compares two vectors and returns GL_TRUE if they are
 * equal (within a certain threshold) or GL_FALSE if not. An epsilon
 * that works fairly well is 0.000001.
 *
 * u - array of 3 GLfloats (GLfloat u[3])
 * v - array of 3 GLfloats (GLfloat v[3])
 */
:BOOLEAN EqualFloat(int unsigned u, v, float epsilon)
USES ESI, EDI
{

float f0, f1, f2;
ESI=u;
EDI=v;

f1=ESI.Vector3.X;
f2=EDI.Vector3.X;

f0=floatAbs( f1 -  f2);
IF (f0 < epsilon) {

		  f1=ESI.Vector3.Y;
		  f2=EDI.Vector3.Y;

		  f0=floatAbs( f1 -  f2);

		  IF (f0 < epsilon) {

					  f1=ESI.Vector3.Z;
					  f2=EDI.Vector3.Z;

					  f0=floatAbs( f1 -  f2);

					  IF (f0 < epsilon) { EAX=1;  RETURN EAX;     }


		                    }

		  }

$XOR EAX, EAX; return EAX;
}//EqualFloat



// 
//LpLpNormals -   
:void CalcNormal(DWORD LpVertex1, LpVertex2, LpVertex3, LpLpNormals)
USES ESI, EDI
{
float x1, y1, z1, x2, y2, z2, x3, y3, z3;
float normal_x;
float normal_y;
float normal_z;
float longueur;

x1=DSFLOAT[LpVertex1];
y1=DSFLOAT[LpVertex1+4];
z1=DSFLOAT[LpVertex1+4+4];

x2=DSFLOAT[LpVertex2];
y2=DSFLOAT[LpVertex2+4];
z2=DSFLOAT[LpVertex2+4+4];

x3=DSFLOAT[LpVertex3];
y3=DSFLOAT[LpVertex3+4];
z3=DSFLOAT[LpVertex3+4+4];

//-- now use these coordz to calculate normals (xyz) of each polygon
//coa = -(py1 * (pz2-pz3) + py2*(pz3-pz1) + py3*(pz1-pz2))
asm {

fld  z2
fsub z3
fmul y1
fld  z3
fsub z1
fmul y2
fld  z1
fsub z2
fmul y3
faddp st(1),st(0)
faddp st(1),st(0)
fchs
fstp normal_x		//save it


//cob = -(pz1 * (px2-px3) + pz2*(px3-px1) + pz3*(px1-px2))

fld  x2
fsub x3
fmul z1
fld  x3
fsub x1
fmul z2
fld  x1
fsub x2
fmul z3
faddp st(1),st(0)
faddp st(1),st(0)
fchs
fstp normal_y		//save it


//coc = -(px1 * (py2-py3) + px2*(py3-py1) + px3*(py1-py2))

fld  y2
fsub y3
fmul x1
fld  y3
fsub y1
fmul x2
fld  y1
fsub y2
fmul x3
faddp st(1),st(0)
faddp st(1),st(0)
fchs
fstp normal_z		//save it


//--- calculate the length of the normal
//---  
//absvec = sqrt ((double) ((coa*coa) + (cob*cob) + (coc*coc)))
// not useful actually because glNormalize will take care of that
// maybe speed difference, but i didn't noticed
//    ,   glNormalize    
//      ,    .


fld  normal_x
fmul normal_x
fld  normal_y
fmul normal_y
fld  normal_z
fmul normal_z
faddp st(1),st(0)
faddp st(1),st(0)
fsqrt
fstp longueur


//--- normalize this length to 1
// we divide each xyz component by the length of the normal vector
// not useful actually because glNormalize will take care of that
// maybe speed difference, but i didn't noticed
//---    1
//    xyz      
//    ,   glNormalize    
//      ,    .

//  norm[0] = coa/absvec

fld  normal_x
fdiv longueur
fstp normal_x

//  norm[1] = cob/absvec

fld  normal_y
fdiv longueur
fstp normal_y

//  norm[2] = coc/absvec

fld  normal_z
fdiv longueur
fstp normal_z




     }


DSFLOAT[LpLpNormals]=normal_x;
DSFLOAT[LpLpNormals+4]=normal_y;
DSFLOAT[LpLpNormals+4+4]=normal_z;




}














//---------------------------------------------------------------------------------------
//      
//    ...
//10000000 sqrt computed in 761 ticks with standard math funcs
//10000000 sqrt computed in 1082 ticks with Fast Sqrt
// Fast square root
/*********************************************************************
ulSqrt.cpp
Copyright (C) 1999, 2000 NVIDIA Corporation
This file is provided without support, instruction, or implied
warranty of any kind.  NVIDIA makes no guarantee of its fitness
for a particular purpose and is not liable under any circumstances
for any damages or loss whatsoever arising from the use or inability
to use this file or items derived from it.
Comments:
*********************************************************************/

//,      

:float f0_47 = 0.47f;
:float f1_47 = 1.47f;
:float f3_0  = 3.0f;
:float f0_5  = 0.5f;
:float stdcall egwInvSqrt (float x)
{
//    ulong y;
    DWORD y;
    float r;

    asm
    {
        mov     eax, 07F000000h+03F800000h // (ONE_AS_INTEGER<<1) + ONE_AS_INTEGER
        sub     eax, SSDWORD[#x]
        sar     eax, 1
        mov     SSDWORD[#y], eax                      // y
        fld     f0_47                       // 0.47
        fmul    SSDWORD[#x]                 // x*0.47
        fld     SSDWORD[#y]
        fld     st(0)                       // y y x*0.47
        fmul    st(0), st(1)                // y*y y x*0.47
        fld     f1_47                      // 1.47 y*y y x*0.47
        fxch    st(3)                       // x*0.47 y*y y 1.47
        fmulp   st(1)                // x*0.47*y*y y 1.47
        fsubp   st(2)            // y 1.47-x*0.47*y*y
        fmulp   st(1)               // result
        fstp    SSDWORD[#y]
        and     SSDWORD[#y], 07FFFFFFFh
    }

//    r = *(float *) &y;
    r =SSFLOAT[#y];

    // optional
//    r = (3.0f - x * (r * r)) * r * 0.5f; // remove for low accuracy

$fld SSDWORD [#r]
$fmul SSDWORD [#r]
$fmul SSDWORD [#x]
$fsubr f3_0
$fmul SSDWORD [#r]
$fmul f0_5
$fst  SSDWORD [#r]

return r;

}


/*
    sqrt(x) = x / sqrt(x)
*/

:float stdcall egwSqrt (float x)
{
float x1;
x1=egwInvSqrt(x);
x=x * x1;
return x;
}



//2.4494897427831777280
//2.4494897427831777280
//2.009871
//4.019743/2=2.0098715


//
/*
struct  Quaternion {
float   w;
Vector3 Vector;
};
*/

/*
// NegateVector
// EAX contains address of v
//  
:void fastcall  NegateVector(EAX)
{
asm {
      FLD DSFLOAT[EAX]
      FCHS
      FSTP DSFLOAT[EAX]
      FLD DSFLOAT[EAX+4]
      FCHS
      FSTP DSFLOAT[EAX+4]
      FLD DSFLOAT[EAX+8]
      FCHS
      FSTP DSFLOAT[EAX+8]
    }
}

*/


/*
// ScaleVector (affine)
//
:void fastcall ScaleVector(EAX,  EBX)
{
asm {
      FLD  DSFLOAT [EAX]
      FMUL DSFLOAT [EBX]
      FSTP DSFLOAT [EAX]

      FLD  DSFLOAT [EAX+4]
      FMUL DSFLOAT [EBX]
      FSTP DSFLOAT [EAX+4]

      FLD  DSFLOAT [EAX+8]
      FMUL DSFLOAT [EBX]
      FSTP DSFLOAT [EAX+8]
    }
}
*/


:void CopyVector(DWORD LpV1, LpOut)
USES EAX, EBX
{
EAX=LpV1;
EBX=LpOut;


asm {
 fld  DSFLOAT[eax]
 fstp DSFLOAT[ebx]
 fld  DSFLOAT[eax+4]
 fstp DSFLOAT[ebx+4]
 fld  DSFLOAT[eax+8]
 fstp DSFLOAT[ebx+8]
 }

}



// Add two vectors and store result into third one.
// IN: ESI=Ptr to vec1
//     EDI=Ptr to vec2
//:void fastcall VectorAdd(ESI,  EDI,  EBX)
//     EBX=Ptr to result vector
:void VectorAdd(DWORD Lp1,  Lp2, Lp3)
//     EBX=Ptr to result vector
USES ESI, EDI, EBX
{
ESI=Lp1;
EDI=Lp2;
EBX=Lp3;

$fld  DSFLOAT [ESI]
$fadd DSFLOAT [EDI]
$fstp DSFLOAT [EBX]
$fld  DSFLOAT [ESI+4]
$fadd DSFLOAT [EDI+4]
$fstp DSFLOAT [EBX+4]
$fld  DSFLOAT [ESI+8]
$fadd DSFLOAT [EDI+8]
$fstp DSFLOAT [EBX+8]
}





// Vector-scalar (dot) multiplication
// In: ST(0)=scalar
//     EBX=Ptr to vector
:void fastcall MulByScalar(st(0), dword EBX)
USES EBX
{
$fld st(0)
$fld st(0)
$fmul DSFLOAT [ebx]
$fstp DSFLOAT [ebx]
$fmul DSFLOAT [ebx+4]
$fstp DSFLOAT [ebx+4]
$fmul DSFLOAT [ebx+8]
$fstp DSFLOAT [ebx+8]
}



// In: ESI=ptr to vec1(A.x, A.y, A.z)
//     EDI=ptr to vec2(B.x, B.y, B.z)
//    EBX=ptr to dword to store result in
// Out:
//     Vec[EBX]=A.x*B.x+A.y*B.y+A.z*B.z
:void fastcall DotProduct(dword ESI, EDI, EBX)
USES ESI, EDI, EBX
{
$fld   DSFLOAT [esi]
$fmul  DSFLOAT [edi]
$fld   DSFLOAT [esi+4]
$fmul  DSFLOAT [edi+4]
$faddp st(1)
$fld   DSFLOAT [esi+8]
$fmul  DSFLOAT [edi+8]
$faddp st(1)
$fstp  DSFLOAT [ebx]
}



// In: ESI=Ptr to vec1 (A.x, A.y, A.z)
//    EDI=Ptr to vec2 (B.x, B.y, B.z)
//     EBX=Ptr to result vec
// Out:
// vec[EBX]=(A.y*B.z-B.y*A.z, A.z*B.x-B.z*A.x, A.x*B.y-B.x*A.y)
:void fastcall CrossProduct(dword ESI, EDI, EBX)
USES ESI, EDI, EBX
{
$fld DSFLOAT [esi]
$fld st(0)
$fmul DSFLOAT [edi+8]
$fxch
$fmul DSFLOAT [edi+4]
//***
$fld DSFLOAT [esi+4]
$fld st(0)
$fmul DSFLOAT [edi+8]
$fxch
$fmul DSFLOAT [edi]
//****
$fld DSFLOAT [esi+8]
$fld st(0)
$fmul DSFLOAT [edi+4]
$fxch
$fmul DSFLOAT [edi]
// 0       1       2       3       4       5
// Az*Bx . Az*By . Ay*Bx . Ay*Bz . Ax*By . Ax*Bz
$fxch st(5)
$fsubp st(5)
$fsubp st(2)
$fsubp st(2)


$fstp DSFLOAT [ebx]
$fstp DSFLOAT [ebx+8]
$fstp DSFLOAT [ebx+4]
}



:float VectorLength(DWORD LpVector)
{
float fOut;

DotProduct(LpVector, LpVector, #fOut);
return sqrt(fOut);

}

/*
  ,  ..        ,  
       :

Vn(xn, yn, zn) = V(x/|V|, y/|V|, z/|V|)

 L -  
*/


/*
float VectorNormalize(float *v)
{
  int i;
  float length;

  if ((length = VectorLength(v)) == 0) return 0;

  for (i = 0; i < 3; i++) v[i] /= length;

	return length;
}
*/


//    
//  0     0
:float VecTmp[3];


:DWORD VectorNormalize(DWORD LpVector)
{

float length;

length=1.0f;

length = VectorLength(LpVector);

if (length==0.0f) {zaplatka1(); return 0;   }
zaplatka1();

	length = 1.0f/length;


VecTmp[0]=DSFLOAT[LpVector]*length;
VecTmp[1]=DSFLOAT[LpVector+4]*length;
VecTmp[2]=DSFLOAT[LpVector+8]*length;

return #VecTmp;

}



:DWORD VectorNormalize2(DWORD LpVector)
USES ESI, EDI, EBX
{

float length;

length=1.0f;

length = VectorLength(LpVector);

IF (length==0.0f) {zaplatka1(); RETURN 0;   }
zaplatka1();

	length = 1.0f/length;


VecTmp[0]=DSFLOAT[LpVector]*length;
VecTmp[1]=DSFLOAT[LpVector+4]*length;
VecTmp[2]=DSFLOAT[LpVector+8]*length;

CopyVector(#VecTmp, LpVector);


}




//-------------------------------------------------
:void VectorInverse (DWORD LpVector)
{


$FLD DSFLOAT[LpVector]
$FCHS
$FSTP DSFLOAT[LpVector]


$FLD DSFLOAT[LpVector+4]
$FCHS
$FSTP DSFLOAT[LpVector+4]

$FLD DSFLOAT[LpVector+4+4]
$FCHS
$FSTP DSFLOAT[LpVector+4+4]


}


//   LpV2  LpV1,    LpOut
:float temp1[3];
:void VectorSub (DWORD LpV1,  LpV2,  LpOut)
{

CopyVector(LpV1, #temp1);
VectorInverse (#temp1);
VectorAdd(#temp1,  LpV2,  LpOut);



}

///
:float E[3];
:float F[3];
:void ComputeNormal( DWORD LpV0, LpV1, LpV2, LpOutNormal)
USES ESI, EDI, EBX
{
/*
	Vector E = V1; E -= V0;
	Vector F = V2; F -= V1;

	Cross(E, F);

	Normalise();
*/

CopyVector(LpV1, #E);
CopyVector(LpV2, #F);

//   LpV2  LpV1,    LpOut
VectorSub(LpV0,  #E,  #E);
VectorSub(LpV1,  #F,  #F);

CrossProduct( #E, #F, LpOutNormal);

VectorNormalize2(LpOutNormal);

}

//--------------------------------------------------------------------------------------------------------------
//This returns the distance between 2 3D points
:float Distance(DWORD vPoint1,  vPoint2)
{
float distance;
	// This is the classic formula used in beginning algebra to return the
	// distance between 2 points.  Since it's 3D, we just add the z dimension:
	//
	// Distance = sqrt(  (P2.x - P1.x)^2 + (P2.y - P1.y)^2 + (P2.z - P1.z)^2 )
	//


$FLD   DSFLOAT[vPoint2]
$FSUB  DSFLOAT[vPoint1]
$FMUL  st(0), st(0)


$FLD   DSFLOAT[vPoint2+4]
$FSUB  DSFLOAT[vPoint1+4]
$FMUL  st(0), st(0)

$FADDP st(1), st(0)

$FLD   DSFLOAT[vPoint2+8]
$FSUB  DSFLOAT[vPoint1+8]
$FMUL  st(0), st(0)

$FADDP st(1), st(0)

$FSQRT

return st(0);



}





//This returns the distance between a plane and the origin ----------------------------------------------------------
:float PlaneDistance(DWORD LpNormal, LpPoint)
{
	// This variable holds the distance from the plane tot he origin

	// Use the plane equation to find the distance (Ax + By + Cz + D = 0)  We want to find D.
	// So, we come up with D = -(Ax + By + Cz)
        // distance = - ((Normal.x * Point.x) + (Normal.y * Point.y) + (Normal.z * Point.z));

$FLD	DSFLOAT[LpNormal]
$FMUL   DSFLOAT[LpPoint]


$FLD	DSFLOAT[LpNormal+4]
$FMUL   DSFLOAT[LpPoint+4]
$FADDP  st(1), st(0)

$FLD	DSFLOAT[LpNormal+8]
$FMUL   DSFLOAT[LpPoint+8]
$FADDP  st(1), st(0)
 													// Basically, the negated dot product of the normal of the plane and the point. (More about the dot product in another tutorial)

$FCHS


return st(0);


}




//This returns the point on the line vA_vB that is closest to the point vPoint -----------------------------------
//       LpvA-LpvB   LpvPoint
:void  ClosestPointOnLine(DWORD LpvA, LpvB, LpvPoint, LpOut)
{

float vVector1[3];
float vVector2[3];
float vVector3[3];
float vClosestPoint[3];
float d;
float t;


	// Create the vector from end point vA to our point vPoint.
          VectorSub (LpvA,  LpvPoint,  #vVector1);


	// Create a normalized direction vector from end point vA to end point vB
          VectorSub (LpvA,  LpvB,  #vVector2);
          VectorNormalize(#vVector2);
          CopyVector(EAX, #vVector2);



	// Use the distance formula to find the distance of the line segment (or magnitude)
          d = Distance(LpvA, LpvB);


	// Using the dot product, we project the vVector1 onto the vector vVector2.
	// This essentially gives us the distance from our projected vector from vA.
          DotProduct(#vVector2, #vVector1, #t);

	// If our projected distance from vA, "t", is less than or equal to 0, it must
	// be closest to the end point vA.  We want to return this end point.
       if (t <= 0.0f) {zaplatka1(); CopyVector(LpvA, LpOut); return ;} zaplatka1();


	// If our projected distance from vA, "t", is greater than or equal to the magnitude
	// or distance of the line segment, it must be closest to the end point vB.  So, return vB.
       if (t >= d)  {zaplatka1(); CopyVector(LpvB, LpOut); return ;} zaplatka1();



	// Here we create a vector that is of length t and in the direction of vVector2
              CopyVector(#vVector2, #vVector3);
              MulByScalar(t, #vVector3);


	// To find the closest point on the line segment, we just add vVector3 to the original
	// end point vA.
        VectorAdd(LpvA, #vVector3, #vClosestPoint);

        CopyVector(#vClosestPoint, LpOut);


}


//-----------------------------------------------------------------------------------------------------------------
//  LpvLineA - LpvLineB   LpPoint, LpNormal
:BOOLEAN IntersectedLinePlane(DWORD LpPoint, LpNormal, LpvLineA, LpvLineB)
{
float originDistance;
float distance, distance1, distance2;


	// Let's find the distance our plane is from the origin.  We can find this value
	// from the normal to the plane (polygon) and any point that lies on that plane (Any vertex)

originDistance=PlaneDistance(LpNormal, LpPoint);

	// Get the distance from point1 from the plane using: Ax + By + Cz + D = (The distance from the plane)



distance1=DSFLOAT[LpNormal]*DSFLOAT[LpvLineA];                          // Ax +
distance1+=DSFLOAT[LpNormal+4]*DSFLOAT[LpvLineA+4];                     // Bx +
distance1+=DSFLOAT[LpNormal+8]*DSFLOAT[LpvLineA+8];                     // Cz + D
distance1+=originDistance;


	// Get the distance from point2 from the plane using Ax + By + Cz + D = (The distance from the plane)


distance2=DSFLOAT[LpNormal]*DSFLOAT[LpvLineB];
distance2+=DSFLOAT[LpNormal+4]*DSFLOAT[LpvLineB+4];
distance2+=DSFLOAT[LpNormal+8]*DSFLOAT[LpvLineB+8];
distance2+=originDistance;


	// Now that we have 2 distances from the plane, if we times them together we either
	// get a positive or negative number.  If it's a negative number, that means we collided!
	// This is because the 2 points must be on either side of the plane (IE. -1 * 1 = -1).

distance=distance1 * distance2;


	if(distance >= 0.0f){zaplatka1(); return FALSE;}			// Check to see if both point's distances are both negative or both positive
	   						// Return false if each point has the same sign.  -1 and 1 would mean each point is on either side of the plane.  -1 -2 or 3 4 wouldn't...


	zaplatka1();
	return TRUE;							// The line intersected the plane, Return TRUE

}

//-----------------------------------------------------------------------------------------------------------------------------

//This returns the intersection point of the line that intersects the plane
//       (   LpPoint   LpNormal)
:IntersectionPoint( DWORD LpOut, DWORD LpPoint, LpNormal, LpLineA, LpLineB)
{

// Variables to hold the point and the line's direction
Vector3 vPoint, vLineDir;
float Numerator, Denominator, dist, distance;
DWORD LpTmp;

// Let's find the distance our plane is from the origin.
distance=PlaneDistance(LpNormal, LpPoint);

	// 1)  First we need to get the vector of our line, Then normalize it so it's a length of 1
//	vLineDir = vLine[1] - vLine[0];		// Get the Vector of the line
        VectorSub (LpLineA,  LpLineB,  #vLineDir);  //      


//	vLineDir = Normalize(vLineDir);				// Normalize the lines vector
         LpTmp=VectorNormalize(#vLineDir);
         CopyVector(LpTmp, #vLineDir);

	// 2) Use the plane equation (distance = Ax + By + Cz + D) to find the
	// distance from one of our points to the plane.

/*
	Numerator = - (vNormal.x * vLine[0].x +		// Use the plane equation with the normal and the line
				   vNormal.y * vLine[0].y +
				   vNormal.z * vLine[0].z2 + distance);
*/

        Numerator=DSFLOAT[LpNormal]*DSFLOAT[LpLineA];
        Numerator+=DSFLOAT[LpNormal+4]*DSFLOAT[LpLineA+4];
        Numerator+=DSFLOAT[LpNormal+8]*DSFLOAT[LpLineA+8];
        Numerator+=distance;
        $FLD Numerator;  $FCHS; $FSTP Numerator;



	// 3) If we take the dot product between our line vector and the normal of the polygon,
//	Denominator = Dot(vNormal, vLineDir);		// Get the dot product of the line's vector and the normal of the plane

        DotProduct(LpNormal, #vLineDir, #Denominator);

/*




	// Since we are using division, we need to make sure we don't get a divide by zero error
	// If we do get a 0, that means that there are INFINATE points because the the line is
	// on the plane (the normal is perpendicular to the line - (Normal.Vector = 0)).
	// In this case, we should just return any point on the line.

	if( Denominator == 0.0)						// Check so we don't divide by zero
		return vLine[0];						// Return an arbitrary point on the line

*/
	if( Denominator == 0.0)	{zaplatka1();
                                               //return vLine[0];
	                                       DSFLOAT[LpOut]=DSFLOAT[LpLineA]; DSFLOAT[LpOut+4]=DSFLOAT[LpLineA+4]; DSFLOAT[LpOut+8]=DSFLOAT[LpLineA+8];


                                }
                                zaplatka1();

//	dist = Numerator / Denominator;				// Divide to get the multiplying (percentage) factor

        dist = Numerator / Denominator;

/*



	// Now, like we said above, we times the dist by the vector, then add our arbitrary point.
	vPoint.x = (float)(vLine[0].x + (vLineDir.x * dist));
	vPoint.y = (float)(vLine[0].y + (vLineDir.y * dist));
	vPoint.z = (float)(vLine[0].z + (vLineDir.z * dist));

	return vPoint;								// Return the intersection point

*/
        vPoint.X=vLineDir.X*dist+DSFLOAT[LpLineA];
        vPoint.Y=vLineDir.Y*dist+DSFLOAT[LpLineA+4];
        vPoint.Z=vLineDir.Z*dist+DSFLOAT[LpLineA+8];

        DSFLOAT[LpOut]=vPoint.X; DSFLOAT[LpOut+4]=vPoint.Y; DSFLOAT[LpOut+8]=vPoint.Z;

}





:TransformInMatrix(int unsigned vec, matrix)
uses ECX, EBX
	{

	float new_vec[3];
	/*
	float new_vec[3];

	new_vec[0] = vec[0] * m->mat[0] + vec[1] * m->mat[4] + vec[2] * m->mat[8] + m->mat[12] + m->mat[3];
	new_vec[1] = vec[0] * m->mat[1] + vec[1] * m->mat[5] + vec[2] * m->mat[9] + m->mat[13] + m->mat[7];
	new_vec[2] = vec[0] * m->mat[2] + vec[1] * m->mat[6] + vec[2] * m->mat[10] + m->mat[14] + m->mat[11];

	Set(new_vec);
	*/
	EBX=vec;
	ECX=matrix;
	$fld EBX.Vector3.X
	$fmul ECX.glMat16.m[0]

	$fld EBX.Vector3.Y
	$fmul ECX.glMat16.m[4]

	$FADDP st(1), st(0)

	$fld EBX.Vector3.Z
	$fmul ECX.glMat16.m[8]
	$fadd ECX.glMat16.m[12]

	$FADDP st(1), st(0)
	$FSTP new_vec[0]
	//--------------------------------------

		$fld EBX.Vector3.X
	$fmul ECX.glMat16.m[1]

	$fld EBX.Vector3.Y
	$fmul ECX.glMat16.m[5]

	$FADDP st(1), st(0)

	$fld EBX.Vector3.Z
	$fmul ECX.glMat16.m[9]
	$fadd ECX.glMat16.m[13]

	$FADDP st(1), st(0)
	$FSTP new_vec[1]
//------------------------------------

		$fld EBX.Vector3.X
	$fmul ECX.glMat16.m[2]

	$fld EBX.Vector3.Y
	$fmul ECX.glMat16.m[6]

	$FADDP st(1), st(0)

	$fld EBX.Vector3.Z
	$fmul ECX.glMat16.m[10]
	$fadd ECX.glMat16.m[14]

$FADDP st(1), st(0)
$FSTP new_vec[2]
//------------------------

$fld new_vec[0]
$fstp EBX.Vector3.X

$fld new_vec[1]
$fstp EBX.Vector3.Y

$fld new_vec[2]
$fstp EBX.Vector3.Z


}
